//-----------------------------------------
// MG Bone Update
//
// By Mike Green (dodgy@shortbutpurple.fsnet.co.uk)
//  
//
@version 2.2
@warnings
@script generic
@name Update Bone


// global values go here
myversion=1;

generic
{


    AutoConfirm(1);
    myscene=Scene();
    GoToFrame(0);

    myoldobj=myscene.firstSelect();
    if (!myoldobj.isMesh())
        error("Please select an object with bones.");
    myoldbone=myoldobj.bone();
    if (!myoldbone)
        error("Please select an object with bones.");

    myactivate=recall("MGUBmyactivate",true);
    myobsolete=recall("MGUBmyobsolete",true);
    mykeepparent=recall("MGUBmykeepparent",false);
    myrecpivot=recall("MGUBmyrecpivot",false);


    reqbegin("MGUpdate Bones Version:"+myversion);
    c0 = ctltext("Warning!","Ensure AutoKey is ON before running this plugin!!");
    c1 = ctlcheckbox("Activate new bones",myactivate);
    c2 = ctlcheckbox("Delete obsolete bones",myobsolete);
    c3 = ctlcheckbox("Record Pivot Rotation",myrecpivot);
    c4 = ctlcheckbox("Preserve current parenting",mykeepparent);

    if (!reqpost())
    {
        AutoConfirm(0);
        return;
    }
    

    // get requester control values here
    myactivate=getvalue(c1);
    myobsolete=getvalue(c2);
    myrecpivot=getvalue(c3);
    mykeepparent=getvalue(c4);

    store("MGUBmyactivate",myactivate);
    store("MGUBmyobsolete",myobsolete);
    store("MGUBmyrecpivot",myrecpivot);
    store("MGUBmykeepparent",mykeepparent);

    reqend();
    tempdir=getdir(TEMPDIR);
    myscenefile=tempdir+"\\MGBoneUpdate_Backup.lws";
    SaveSceneCopy(myscenefile);

// create a clone------------------------------------------------ 
    SelectItem(myoldobj.id);
    Clone(1);
    mynewobj=myscene.firstSelect();
    ClearAllBones();
    SkelegonsToBones();
    mynewbone=mynewobj.bone();    
    if (!mynewbone)
    {   
        SelectItem(mynewobj.id);
        ClearSelected(); 
        AutoConfirm(0);
        return;
    }



// deactivate all bones-------------------------------------------------------

    i=1;
    goalindex=1;
    goals=nil;
    while(myoldbone)
    {
        myactivebones[i][1]=myoldbone;
        myactivebones[i][2]=myoldbone.flags[1];
        SelectItem(myoldbone.id);
        
        if(myoldbone.flags[1])
        {
            BoneActive();
        }
        if(myoldbone.goal)
            {
                goals[goalindex][1]=myoldbone;
                goals[goalindex][2]=myoldbone.goal;
                goalindex++;
                GoalItem(0);
                
            }

        

// remove any pivot rotation------------------------------------------------------------------------
        pivrot=myoldbone.getPivotRotation(0);
        if(pivrot!=<0,0,0>)
        {
//            SelectItem(myoldbone.id);
            SelectItem(myoldbone.id);
            PivotRotation(0,0,0);
            Rotation(pivrot);
        }
//-----------------------------------------------------------------------------------------
    
        i++;
        myoldbone=myoldbone.next();
    }



// see if parent in place is on. Turn it off. 

    mypip=myscene.generalopts[3];
    if(mypip)
    {
        ParentInPlace();
        RefreshNow();
    }



// go through bones in myobj and compare them with new bones
    matchbones=nil;
    matches=1;
    delbones=nil;
    rem=1;

    myoldbone=myoldobj.bone();
    while(myoldbone)
    {
//debug();
        oldboneexists=false;
        mynewbone=mynewobj.bone();    
        while(mynewbone)
        {

            if(myoldbone.name==mynewbone.name)
            {
// remember them, their match, their old parent and the parent of their match
                matchbones[matches][1]=myoldbone;
                matchbones[matches][2]=mynewbone;
                if (mykeepparent)
                    matchbones[matches][3]=true;
                else
                    matchbones[matches][3]=false;
                matchbones[matches][4]=myoldbone.parent;
                matches++;
                oldboneexists=true;
                break;
            }
            mynewbone=mynewbone.next();
        } 
// if they don't have a match, store them for removal
        if (!oldboneexists)
        {
//    info("PIP is "+myscene.generalopts[3]);
            delbones[rem][1]=myoldbone;
            delbones[rem][2]=myoldbone.parent;
//unparent Obsolete bones in case they are affected by the move around. 
            ParentInPlace();
            RefreshNow();
            SelectItem(myoldbone.id);
            ParentItem(myoldobj.id);
            ParentInPlace();
            RefreshNow();

            rem++;
        }
        myoldbone=myoldbone.next();
    }


    

// add the brand new bones
// go through the new bones
// if they don't have a match, add them.
//debug();
    mynewbone=mynewobj.bone();
    i=1;
    while(mynewbone)
    {
        matches=1;
        while(matches<=matchbones.size())
        {
            mymatch=matchbones[matches][2];
            if(mynewbone.id==mymatch.id)
                break;
            matches++;
        }
        if (matches>matchbones.size()) // it found no matches. 
        {
            mysize=matchbones.size();
            SelectItem(myoldobj.id);
            AddBone(mynewbone.name);
            mycreatedbone=myscene.firstSelect();
            mycreatedlist[i]=mycreatedbone;
            i++;
            matchbones[mysize+1][1]=mycreatedbone;
            matchbones[mysize+1][2]=mynewbone;
            matchbones[mysize+1][3]=false;
            matchbones[mysize+1][4]=nil;

        }
        mynewbone=mynewbone.next();
    }

    i=1;

    while(i<=matchbones.size())
    {
//Go through all bones
// and parent them
// to their old parent
// or to their matches parent's match!
        myoldbone=matchbones[i][1];
        mynewbone=matchbones[i][2];
        myoldparent[i]=myoldbone.parent;
        mynewparent=mynewbone.parent;
        if(mynewparent.isBone())
        {
            j=1;
            while(j<=matchbones.size())
            {
                otherparent=matchbones[j][2];
                if(mynewparent.id==otherparent.id)
                {
                    myparent=matchbones[j][1];
                    break;
                 }
                 j++;
            }
        }
        else
        {   
            myparent=myoldobj;
        }
        
        myposition=mynewbone.getPosition(0);
        myrotation=mynewbone.getRotation(0);
        myrestlength=mynewbone.restlength;

        SelectItem(myoldbone.id);
        ParentItem(myparent.id);
        Position(myposition.x,myposition.y,myposition.z);
        BoneRestPosition(myposition.x,myposition.y,myposition.z);
        Rotation(myrotation.x,myrotation.y,myrotation.z);
        BoneRestRotation(myrotation.x,myrotation.y,myrotation.z);
        BoneRestLength(myrestlength);

        i++;
    }
//bones are in the right place, now to reparent them to old bones.
    ParentInPlace();
    RefreshNow();
//reparent the obsolete bones first....
    n=1;
    while(n<=delbones.size())
    {
        SelectItem(delbones[n][1].id);
        ParentItem(delbones[n][2].id);
        n++;
    }

// now reparent the rest!

    if(mykeepparent)
    {
        i=1;
        while (i<=matchbones.size())
        {
            myoldbone=matchbones[i][1];
            myparent=myoldbone.parent;
            if(matchbones[i][4])
            {
                myparent=matchbones[i][4];
            // check to see if parent will exist
                if(myobsolete)
                {
                    n=1;
                    while(n<=delbones.size())
                    {
                        if (myparent.id==delbones[n][1].id)
                        {
                            myparent=myparent.parent;
                            n=0;
                        }
                        n++;
                    }
                }
            }
            SelectItem(matchbones[i][1].id);
            ParentItem(myparent.id);
            i++;
        }
    }
    

//record the pivots
    if(myrecpivot)
    {
        mybone=myoldobj.bone();
        while(mybone)
        {   
            if(!mybone.target)  // don't record pivots if bone has a target!
            {
                SelectItem(mybone.id);
                RecordPivotRotation();
            }
            mybone=mybone.next();
        }
    }
//Activate all the old bones
    i=1;
    while(i<=myactivebones.size())
    {
        if(myactivebones[i][2])
            {
                SelectItem(myactivebones[i][1].id);
                RecordRestPosition();
            }
        i++;
    }

// activate the new bones.
    if(myactivate)
    {
        i=1;
        while(i<=mycreatedlist.size())
        {   
            SelectItem(mycreatedlist[i].id);
            RecordRestPosition();
            i++;
        }
    }

//Add goals back in....-----------------------------------------------------------**
    i=1;
    while(i<=goals.size())
    {
        SelectItem(goals[i][1].id);
        GoalItem(goals[i][2].id);
        i++;
    }
// remove old bones

    if (myobsolete)
    {
        if(delbones)
        {
            mybone=delbones[1][1];
            SelectItem(mybone.id);
            i=2;
            while(i<=delbones.size())
            {   
                if(delbones[i][1].id)
                {   
                    mybone=delbones[i][1];
                    AddToSelection(mybone.id);
                }
                i++;
            }
            ClearSelected();
        }
    }
    

    ParentInPlace();
    RefreshNow();


//remove new obj

    SelectItem(mynewobj.id);
//    AddPosition(0,2,0);
    ClearSelected();
//if parent in place was on, turn it on

    if(mypip)
    {
        ParentInPlace();
        RefreshNow();
    }
    
    AutoConfirm(0);
}








